//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "setup.h"
#include "lang.h"
#include "winutil.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSetupForm *SetupForm;

//---------------------------------------------------------------------------
__fastcall TSetupForm::TSetupForm(TComponent* Owner)
        : TForm(Owner)
{
   HotkeyLabel->Caption=LangText(TE_Hotkey);
   Caption=LangText(TE_Options);
   OKButton->Caption=LangText(TE_OK);
   CancelButton->Caption=LangText(TE_Cancel);
   StartAsGroup->Caption=LangText(TE_StartSetting);
   ActiveRadio->Caption=LangText(TE_Active);
   InactiveRadio->Caption=LangText(TE_Inactive);
   LastRadio->Caption=LangText(TE_LastSetting);
   HotkeyGroup->Caption=LangText(TE_HotkeyFunction);
   ConvertRadio->Caption=LangText(TE_ConvertNow);
   ToggleRadio->Caption=LangText(TE_ToggleActive);

   StripWSCheck->Caption      = LangText(TE_StripWS);
   StripCRRadio->Caption      = LangText(TE_StripCR);
   OnlyCopyLinksRadio->Caption= LangText(TE_OnlyCopyLinks);
   WindowsStartCheck->Caption = LangText(TE_StartWWin);
   UninstallCheck->Caption    = LangText(TE_Uninstall);
   HelpLabel->Caption         = LangText(TE_OnlineHelp);

}
//---------------------------------------------------------------------------


Classes::TShortCut __fastcall TSetupForm::GetHotKey()
{
   return GetRegInt("HotKey");
}



void __fastcall TSetupForm::FormShow(TObject *Sender)
{
   HotKey1->HotKey=GetHotKey();
   ActiveRadio->Checked=false;
   InactiveRadio->Checked=false;
   LastRadio->Checked=false;
   switch(GetRegInt("StartAs"))
   {
      case 1: InactiveRadio->Checked=true; break;
      case 2: LastRadio->Checked=true; break;
      default: ActiveRadio->Checked=true; break;
   }
   if (GetRegInt("HotKeyFunction")==1)
      ConvertRadio->Checked=true;
   else
      ToggleRadio->Checked=true;

   StripWSCheck->Checked=GetRegInt("StripWS");
   StripCRRadio->Checked=GetRegInt("StripCR");
   OnlyCopyLinksRadio->Checked=GetRegInt("OnlyCopyLinks");

   WindowsStartCheck->Checked=HasStartup();

   UninstallCheck->Checked=false;


}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::OKButtonClick(TObject *Sender)
{

   if (UninstallCheck->Checked)
   {
      Deinstall();
      RemoveStartup();
      ModalResult = mrOk;
   }
   else
   {
      short StartAs=-1;
      if (ActiveRadio->Checked) StartAs=0;
      else if (InactiveRadio->Checked) StartAs=1;
      else if (LastRadio->Checked) StartAs=2;
      if (ConvertRadio->Checked)
         SetRegInt("HotKeyFunction", 1);
      else if (ToggleRadio->Checked)
         SetRegInt("HotKeyFunction", 0);
      SetRegInt("StartAs", StartAs);
      SetRegInt("HotKey", HotKey1->HotKey);
      SetRegInt("StripWS", StripWSCheck->Checked);
      SetRegInt("StripCR", StripCRRadio->Checked);
      SetRegInt("OnlyCopyLinks", OnlyCopyLinksRadio->Checked);
      if (WindowsStartCheck->Checked)
         InstallStartup();
      else
         RemoveStartup();
      ModalResult = mrOk;
   }
}
//---------------------------------------------------------------------------
void __fastcall TSetupForm::CancelButtonClick(TObject *Sender)
{
ModalResult = mrCancel;
}

void __fastcall TSetupForm::DeinstallAll()
{
}

void __fastcall TSetupForm::Deinstall()
{
  TRegistry *Registry = new TRegistry(KEY_READ);
  DeinstallUser(Registry);
}

void __fastcall TSetupForm::DeinstallUser(TRegistry *Registry)
{
  bool RemoveKlan=false;
  try
  {
    if (Registry->KeyExists("Software")) {
       Registry->OpenKey("Software",false);
       if (Registry->KeyExists("The Hovgaard Klan")) {
         Registry->OpenKey("The Hovgaard Klan",false);
         if (Registry->KeyExists("HovText")) {
            Registry->DeleteKey("HovText");
         }
         RemoveKlan=!Registry->HasSubKeys();
       }
    }
  }
  catch (...)
  {
  }
  delete Registry;
  if (RemoveKlan)
  {
    Registry = new TRegistry(KEY_READ);
    try
    {
       Registry->OpenKey("Software",false);
       Registry->DeleteKey("The Hovgaard Klan");
    }
    catch (...)
    {
    }
    delete Registry;
  }
}
//---------------------------------------------------------------------------



void __fastcall TSetupForm::UninstallCheckClick(TObject *Sender)
{
  if (UninstallCheck->Checked &&
     (Application->MessageBox(LangText(TE_UninstallConfirm).c_str(),LangText(TE_Uninstall).c_str(),MB_YESNO	)==IDNO))
  {
    UninstallCheck->Checked=false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TSetupForm::URLLabelClick(TObject *Sender)
{
  ShellExecute(NULL,"open", URLLabel->Caption.c_str(),NULL,NULL,SW_RESTORE );
}
//---------------------------------------------------------------------------

